#include <lpc11xx.h>
#include "gpio.h"

void GPIO_Configuration(void);
void  Delay (uint32_t nCount);

int main(void)
{
	uint8_t key=1;
	GPIOInit();
	GPIO_Configuration();
	while(1)
	{
 		/*8IOs PIO0_11  PIO1_0..2 PIO1_4..7 */

		if((LPC_GPIO0->DATA&(1<<11))!=(1<<11))
			key=2;
		if((LPC_GPIO1->DATA&(1<<0))!=(1<<0))
			key=3;
		if((LPC_GPIO1->DATA&(1<<1))!=(1<<1))
			key=4;
		
		if((LPC_GPIO1->DATA&(1<<2))!=(1<<2))
			key=5;
		if((LPC_GPIO1->DATA&(1<<4))!=(1<<4))
			key=5;
		if((LPC_GPIO1->DATA&(1<<5))!=(1<<5))
			key=4;
		if((LPC_GPIO1->DATA&(1<<6))!=(1<<6))
			key=3;
		if((LPC_GPIO1->DATA&(1<<7))!=(1<<7))
			key=2;

	   switch(key)
	   {
			case 0:	
			GPIOSetValue(PORT3,0,LOW);
			GPIOSetValue(PORT3,1,LOW);
			GPIOSetValue(PORT3,2,LOW);
			GPIOSetValue(PORT3,3,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,0,HIGH);
			GPIOSetValue(PORT3,1,HIGH);
			GPIOSetValue(PORT3,2,HIGH);
			GPIOSetValue(PORT3,3,HIGH);
			Delay(0xfffff);
			break;
		
			case 1:
			GPIOSetValue(PORT3,0,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,0,HIGH);

			GPIOSetValue(PORT3,1,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,1,HIGH);
			GPIOSetValue(PORT3,2,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,2,HIGH);
			GPIOSetValue(PORT3,3,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,3,HIGH);
			break;

			case 2:
			GPIOSetValue(PORT3,0,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,0,HIGH);
			Delay(0xfffff);
			break;

			case 3:
			GPIOSetValue(PORT3,1,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,1,HIGH);
			Delay(0xfffff);
			break;

			case 4:
			GPIOSetValue(PORT3,2,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,2,HIGH);
			Delay(0xfffff);
			break;

			case 5:
			GPIOSetValue(PORT3,3,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,3,HIGH);
			Delay(0xfffff);
			break;

			case 6:
			GPIOSetValue(PORT3,0,LOW);
			GPIOSetValue(PORT3,1,LOW);
			GPIOSetValue(PORT3,2,LOW);
			GPIOSetValue(PORT3,3,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT3,0,HIGH);
			GPIOSetValue(PORT3,1,HIGH);
			GPIOSetValue(PORT3,2,HIGH);
			GPIOSetValue(PORT3,3,HIGH);
			Delay(0xfffff);
			break;
		}	

	}	
}

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/

void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT3,0,OUT);
	GPIOSetDir(PORT3,1,OUT);
	GPIOSetDir(PORT3,2,OUT);
	GPIOSetDir(PORT3,3,OUT);

 /*8IOs PIO0_11  PIO1_0..2 PIO1_4..7 */
	GPIOSetDir(PORT0,11,IN);
	GPIOSetDir(PORT1,0,IN);
	GPIOSetDir(PORT1,1,IN);
	GPIOSetDir(PORT1,2,IN);
	GPIOSetDir(PORT1,4,IN);
	GPIOSetDir(PORT1,5,IN);
	GPIOSetDir(PORT1,6,IN);
	GPIOSetDir(PORT1,7,IN);

			
}

