/******************************************************************************
    if you want using PIO1_3 as ADC channel ,please define macro __SWD_DISABLED,
    be carefull.
	if __SWD_DISABLED,please using ISP to unlock this pin.
*******************************************************************************/
#include <lpc11xx.h>
#include <stdio.h>
#include "systick_delay.h"

#ifndef CONFIG_ENABLE_DRIVER_ADC
#define CONFIG_ENABLE_DRIVER_ADC    1
#endif

#include "adc.h"
#include "uart.h"

/******************************************************************************
**   Main Function  main()
**
******************************************************************************/
#define Open_ADC0
//#define Open_ADC1
//#define Open_ADC2
//#define Open_ADC3
//#define Open_ADC4

int main (void)
{
	 /* Basic chip initialization is taken care of in SystemInit() called
	   * from the startup code. SystemInit() and chip settings are defined
	   * in the CMSIS system_<part family>.c file.
	   */

    uint32_t i;
    UART_init(115200); // Init UART

    /* Initialize ADC  */
    ADCInit( ADC_CLK );
    printf("ADC init ok\r\n");
   
    while(1)
    {
		#ifdef	Open_ADC0
		   printf("ADC Channel%d=%d\r\n",i,ADCRead(0));
		#endif
		#ifdef	Open_ADC1
		   printf("ADC Channel%d=%d\r\n",i,ADCRead(1));
		#endif
		#ifdef	Open_ADC2
		   printf("ADC Channel%d=%d\r\n",i,ADCRead(2));
		#endif
		#ifdef	Open_ADC3
		   printf("ADC Channel%d=%d\r\n",i,ADCRead(3));
		#endif
		#ifdef	Open_ADC4
		   printf("ADC Channel%d=%d\r\n",i,ADCRead(4));
		#endif
		delay_ms(10000);

    }
}

