#include "LPC11xx.h"                                                    /* LPC11xx Peripheral Registers */
#include "can_reg_cfg.h"
#include "dataType.h"
#include "can.h"
#include "zlg_can.h"
#include "uart.h"

/*********************************************************************************************************
  CAN ģ
*********************************************************************************************************/
CANNODEINFO *GptCanNode0;                                               /* ָCAN0Ľڵָ       */
const CANFRAME GtCanFramTest = {                                        /* CANͨʱ͵֡    */
    XTD_DATA,                                                           /* չ֡                       */
    8,                                                                  /* 򳤶Ϊ8                */
    0x123,                                                              /* IDΪ0x123                */
    {0x55,0xAA,0x55,0xAA,0x03,0x02,0x01,0x00}                           /*                    */
};


CANFRAME GtCanFrameReBuf[CAN_BUF_RE_LENGTH] = {0};                      /* CANͨŽջ            */
CANFRAME GtCanFrameTxBuf[CAN_BUF_TX_LENGTH] = {0};                      /* CANͨŷͻ            */

CANCIRBUF GtCanReCirBuf = {                                             /* ѭ             */
    0,                                                                  /* дָ루           */
    0,                                                                  /* ָ루           */
    false,                                                              /* Ƕδ                 */
    CAN_BUF_RE_LENGTH,                                                  /* ¼                 */
    GtCanFrameReBuf                                                     /* ָݳ             */
};

CANCIRBUF GtCanTxCirBuf = {                                             /* 巢ѭ             */
    0,                                                                  /* Buffer[]д±           */
    0,                                                                  /* Buffer[]±           */
    false,                                                              /* Ƕδ                 */
    CAN_BUF_TX_LENGTH,                                                  /* ¼                 */
    GtCanFrameTxBuf                                                     /* ָݳ             */
};

/*********************************************************************************************************
  ȫֱ
*********************************************************************************************************/
unsigned long    GulSysClock     =  12000000UL;                         /* ¼ʱƵ           */

void SysCtlDelay(unsigned long ulCount);                                /* ʱ                     */
void intMasterEnable(void);                                             /* ж                   */

/*********************************************************************************************************
  CANڵ0жϷ
*********************************************************************************************************/
void CAN_IRQHandler (void)
{
    canHandler(GptCanNode0);
}

/*********************************************************************************************************
  CANڵ0ķͺ
*********************************************************************************************************/
unsigned char canDataSend(CANFRAME *ptCanFrame)
{
    /* 
	 *  յͻ 
	 */
    if (canCirBufWrite(&GtCanTxCirBuf, ptCanFrame) != CAN_OK) {
        return CAN_ERROR;                                               /*                      */
        
    }
    if (canCirBufSend(GptCanNode0, &GtCanTxCirBuf) == BUSY) {
        
		/* 
		 *  һ֡δ꣬֡ĽڷжϳԶɷ
		 */
        GptCanNode0->ucNodeState |= CAN_SEND_FAIL;
        return BUSY;
    }
    return CAN_OK;                                                      /* ʱ                     */
}

/*********************************************************************************************************
** Function name:           main
** Descriptions:            ÷ʾͨUSBCAN,TinyM0-CANPCCANͨţΪ500Kbps
**                          עǻLPC11C14CANĴûҲѡͨLPC11C14Ƭ
**                              CAN APIʵCANͨţϸCAN_RecSend_API
**                          
** input parameters:        
** output parameters:       
** Returned value:          
** Created By:              
** Created date:            2008.09.03
**--------------------------------------------------------------------------------------------------------
** Modified by:				
** Modified date:			2010.06.01
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
int main(void)
{
    uint i;
    /* 
	 *  岢ʼʾCANڵĽṹ	
	 */
    CANNODEINFO  tCanNode0 = CANNODE(LPC_CAN_BASE,                      /* CANĴַ                */
	                                 CANBAUD_500K,                      /* CAN                    */
									 RE_DATA_SN,                        /* λѡ뱨Ķ   */
	                                 RE_REMOTE_SN,	                    /* λѡԶ뱨Ķ   */
									 TX_MSG_SN,		                    /* ͱĶ             */
									 &GtCanReCirBuf,	                /* ָ򱾽ڵĽջ       */
									 0,
									 0);
    CANFRAME     tCanFrame;                
    
                                 /* ʾCAN֡ṹ      */
   
    SystemInit();
		                                                    /* ϵͳʱӳʼ               */
	UART_init(115200); // ڣò
    printf("Use the welcome Open11C14 development board!\r\n");

    GptCanNode0 = &tCanNode0;                                           /* ָṹ               */
    
    /*
	 *  ͼʽCAN(0x123)  
	 */
    canApplyInit(GptCanNode0, 0x123, UNMASK, STD_ID_FILTER|EXT_ID_FILTER);
                                                                        /* ʼCAN,òʵ */
    intMasterEnable(); 
                                                     /* ʹжܿ               */
    canDataSend((CANFRAME *)&GtCanFramTest);   /* Ͳ*/

    printf("The data sent:");
    for(i=0;i<8;i++)
    {
        printf("0x%x ",GtCanFramTest.ucDatBuf[i]);   
    }
    printf("\r\n");

    while (1) 
    {

        while (canCirBufRead(GptCanNode0->ptCanReCirBuf, &tCanFrame) == CAN_OK)
        
       {
                                                                       /* սջе         */         
            canDataSend((CANFRAME *)&tCanFrame);                        /* յ  */
            printf("The data accept: ");
            for(i=0;i<8;i++)
            {
                printf("0x%x ",tCanFrame.ucDatBuf[i]);   
            }
                         
            printf("\r\n");
            printf("CAN TEST OK");
            while(1);
        }      
        /* 
		 *  ߽״̬ж	 
		 */
        if ((GptCanNode0->ucNodeState & CAN_BUS_OFF) && (GptCanNode0->ulBofTimer > 125)) {
                                                                        /* CAN            */
            canNodeBusOn(GptCanNode0);                                  /* 2.5ڵ          */
            GptCanNode0->ucNodeState &= ~CAN_BUS_OFF;                   /* ߱־                 */
        }

        
        SysCtlDelay(20 * (GulSysClock / 3000));                         /* ʱԼ20ms                   */
        if(GptCanNode0->ulBofTimer < 65535) {
            GptCanNode0->ulBofTimer++;
        }
        
        /* 
		 *  ͳɹ	
		 */
        if (GptCanNode0->ucNodeState & CAN_FRAM_SEND)                   /*                      */
		{   
             printf("send OK \r\n");              
            GptCanNode0->ucNodeState &= ~CAN_FRAM_SEND;                 /* ɱ־             */
        }
        
        /* 
		 *  ʧ	
		 */
        if (GptCanNode0->ucNodeState & CAN_SEND_FAIL) 					/* ʧ                     */
		{                
            GptCanNode0->ucNodeState &= ~CAN_SEND_FAIL;                 /* ʧܱ־             */
             printf("send failure \r\n"); 
       
        } 



    }                                                                   /* End while (1)                */
}

#if defined(ewarm) || defined(DOXYGEN)
void SysCtlDelay(unsigned long ulCount)
{
    __asm("    subs    r0, #1\n"
    "    bne.n   SysCtlDelay\n"
    "    bx      lr");
}
#endif

#if defined(codered) || defined(gcc) || defined(sourcerygxx)
void __attribute__((naked))	SysCtlDelay(unsigned long ulCount)
{
    __asm("    subs    r0, #1\n"
    "    bne     SysCtlDelay\n"
    "    bx      lr");
}
#endif

#if defined(rvmdk) || defined(__ARMCC_VERSION)
__asm void SysCtlDelay(unsigned long ulCount)
{
    subs    r0, #1;
    bne     SysCtlDelay;
    bx      lr;
}

__asm void intMasterEnable() {
    CPSIE   I                                                           /* ж                   */
    BX      LR
}
#endif

/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
