/****************************************Copyright (c)****************************************************
**                               Guangzhou ZHIYUAN electronics Co.,LTD.
**
**                                 http://www.embedtools.com
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:               zlg_can.c
** Last modified Date:      2010.02.25
** Last Version:            1.0
** Description:             CAN API,ھж·CANCPU
**--------------------------------------------------------------------------------------------------------
** Created By:              չ
** Created date:            2010.02.25
** Version:                 1.0
** Descriptions:            The original version ʼ汾
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/

#include "LPC11xx.h"                                                    /* LPC11xx Peripheral Registers */
#include "zlg_can.h"
#include "can.h"

#include "can_reg_cfg.h"
//#include "interrupt.h"

/*********************************************************************************************************
ʲ
һμλ1ĺͣȡֵΧ216
ڶλ2ȡֵΧ18
ͬתȣȡֵΧ14
ƵֵȡֵΧ11024
*********************************************************************************************************/
const CAN_BIT_CLK_PARM CANBitClkSettings[] =
{
    
    /*
    *  Fcan = 50MHz
    */
    #if FCAN == FCAN48M
    {15, 8, 4, 2},                                                      /* CANBAUD_1M                   */
    {15, 8, 4, 4},                                                      /* CANBAUD_500K                 */
    {15, 8, 4, 8},                                                      /* CANBAUD_250K                 */
    {15, 8, 4, 16},                                                     /* CANBAUD_125K                 */
    {15, 8, 4, 20},                                                     /* CANBAUD_100k                 */
    {15, 8, 4, 40},                                                     /* CANBAUD_50k                  */
    {15, 8, 4, 80},                                                     /* CANBAUD_25k                  */
    {15, 8, 4, 100},                                                    /* CANBAUD_20k                  */
    {15, 8, 4, 200},                                                    /* CANBAUD_10k                  */
    {15, 8, 4, 400},                                                    /* CANBAUD_5k                   */
    {15, 8, 4, 800},                                                    /* CANBAUD_2k5                  */
    
    
    #elif FCAN == FCAN6M
    /*
    *  Fcan = 6MHz
    */
    {3, 2, 2, 1},                                                       /* CANBAUD_1M                   */
    {6, 5, 4, 1},                                                       /* CANBAUD_500K                 */
    {6, 5, 4, 2},                                                       /* CANBAUD_250K                 */
    {15, 8, 4, 2},                                                      /* CANBAUD_125K                 */
    {11, 8, 4, 3},                                                      /* CANBAUD_100k                 */
    {15, 8, 4, 5},                                                      /* CANBAUD_50k                  */
    {15, 8, 4, 10},                                                     /* CANBAUD_25k                  */
    {16, 8, 4, 12},                                                     /* CANBAUD_20k                  */
    {15, 8, 4, 25},                                                     /* CANBAUD_10k                  */
    {15, 8, 4, 50},                                                     /* CANBAUD_5k                   */
    {15, 8, 4, 100},                                                    /* CANBAUD_2k5                  */
    
    
    #elif FCAN == FCAN2M
    /*
    *  Fcan = 2MHz
    */
    {0, 0, 0, 0},                                                       /* CANBAUD_1M ޷ﵽ      */
    {2, 1, 1, 1},                                                       /* CANBAUD_500K                 */
    {4, 3, 3, 1},                                                       /* CANBAUD_250K                 */
    {4, 3, 3, 2},                                                       /* CANBAUD_125K                 */
    {5, 4, 4, 2},                                                       /* CANBAUD_100k                 */
    {5, 4, 4, 4},                                                       /* CANBAUD_50k                  */
    {5, 4, 3, 8},                                                       /* CANBAUD_25k                  */
    {5, 4, 3, 10},                                                      /* CANBAUD_20k                  */
    {5, 4, 3, 20},                                                      /* CANBAUD_10k                  */
    {5, 4, 3, 40},                                                      /* CANBAUD_5k                   */
    {5, 4, 3, 80},                                                      /* CANBAUD_2k5                  */
    
    
    #else
    /*
    *  Fcan = 8MHz
    */
    {4, 3, 3, 1},                                                       /* CANBAUD_1M                   */
    {8, 7, 4, 1},                                                       /* CANBAUD_500K                 */
    {8, 7, 4, 2},                                                       /* CANBAUD_250K                 */
    {11, 4, 4, 4},                                                      /* CANBAUD_125K                 */
    {11, 4, 4, 5},                                                      /* CANBAUD_100k                 */
    {11, 4, 4, 10},                                                     /* CANBAUD_50k                  */
    {11, 4, 4, 20},                                                     /* CANBAUD_25k                  */
    {11, 4, 4, 25},                                                     /* CANBAUD_20k                  */
    {11, 4, 4, 50},                                                     /* CANBAUD_10k                  */
    {11, 4, 4, 100},                                                    /* CANBAUD_5k                   */
    {11, 4, 4, 200},                                                    /* CANBAUD_2k5                  */
    
    
    #endif
}; 


/*********************************************************************************************************
** ڳʼCAN
*********************************************************************************************************/
const CANFRAME GtCanFrameInit = {
    BUF_BLANK,                                                          /* հ֡                       */
    0,                                                                  /* 򳤶Ϊ0                */
    0,                                                                  /* IDΪ                     */
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}                           /*                    */
};
/*********************************************************************************************************
** Function name:           canCirBufInit
** Descriptions:            ʼ֡FIFO
** input parameters:        ptBuf      ָѭеָ
** output parameters:       
** Returned value:          
** Created By:              չ
** Created date:            2008.09.03
**--------------------------------------------------------------------------------------------------------
** Modified by:             չ
** Modified date:           2009.04.29
** Descriptions:            ֡͸ʽʼΪBUF_BLANKڷֹ
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canCirBufInit(CANCIRBUF *ptCanCirBuf, CANFRAME *ptCanFrameBuf, INT8U ucLength)
{
    unsigned int i;
    
    ptCanCirBuf->ulWriteIndex    = 0;                                   /* Buffer[]д±           */
    ptCanCirBuf->ulReadIndex     = 0;                                   /* Buffer[]±           */
    ptCanCirBuf->bIsFull         = false;                               /* ѭв                 */
    ptCanCirBuf->ulLength        = ucLength;                            /* ¼,ֵ    */
    ptCanCirBuf->ptCanFramBuf    = ptCanFrameBuf;                       /* ָݻ׵ַ         */
    for (i = 0; i < ucLength; i++) {
        ptCanCirBuf->ptCanFramBuf[i] = GtCanFrameInit;                  /* ʼΪ֡                 */
    }
}

/*********************************************************************************************************
** Function name:           canCirBufMalloc
** Descriptions:            ѭУFIFOһ֡ ֡͸ʽʼΪBUF_BLANK
** input parameters:        ptBuf          ָѭеָ
** output parameters:       
** Returned value:          ptCanFrame     ַ֡Ϊ0ʾѭ
** Created By:              չ
** Created date:            2008.09.02
**--------------------------------------------------------------------------------------------------------
** Modified by:             չ
** Modified date:           2009.04.29
** Descriptions:            ٽ
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
static CANFRAME *canCirBufMalloc(CANCIRBUF *ptCanCirBuf)
{
    CANFRAME  *ptCanFrame;
    unsigned char ucEnable = 0;
    
    if (ptCanCirBuf == (CANCIRBUF *)0) {
        return 0;                                                       /* д                     */
    }
    if (ptCanCirBuf->bIsFull == true) {
        return 0;                                                       /* ,򷵻 0              */
    }
    
    ucEnable = __ENTER_CIRTICAL();                                      /* ٽ                   */
    ptCanFrame = &(ptCanCirBuf->ptCanFramBuf[ptCanCirBuf->ulWriteIndex++]);
                                                                        /* ȡҪصĵַ           */
    if (ptCanCirBuf->ulWriteIndex == ptCanCirBuf->ulLength) {
        ptCanCirBuf->ulWriteIndex = 0;                                  /* ѭ                 */
    }
    if (ptCanCirBuf->ulWriteIndex == ptCanCirBuf->ulReadIndex) {        /* дָ϶ָ룬     */
        ptCanCirBuf->bIsFull = true;                                    /* λ־               */
    }
    __EXIT_CIRTICAL(ucEnable);                                          /* ˳ٽ                   */
    
    *ptCanFrame = GtCanFrameInit;                                       /* ʼĴ洢ռ         */
    return ptCanFrame;
}

/*********************************************************************************************************
** Function name:           canCirBufRead
** Descriptions:            ѭжȡһ֡
** input parameters:        ptCanBuf       ָѭеָ
** output parameters:       ptFrame        ָ
** Returned value:          EMPTY          ѭΪգѭ޿
**                          NOT_EMPTY      ѭзǿ
**                          CAN_ERROR           ѭд󣬲ʧ
** Created By:              չ
** Created date:            2008.09.02
**--------------------------------------------------------------------------------------------------------
** Modified by:             չ
** Modified date:           2009.04.29
** Descriptions:            ٽ
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
INT8U canCirBufRead(CANCIRBUF *ptCanCirBuf, CANFRAME  *ptCanFrame)
{
    INT8U  ucReturn = CAN_ERROR;
    unsigned long ulIndex;
    unsigned char ucEnable = 0;
    
    if (ptCanCirBuf == (CANCIRBUF *)0) {
        return CAN_ERROR;                                               /* д                     */
    }
    
    ucEnable = __ENTER_CIRTICAL();                                      /* ٽ                   */
    
    if ((ptCanCirBuf->ulReadIndex != ptCanCirBuf->ulWriteIndex) || (ptCanCirBuf->bIsFull == true)) {
        ulIndex = ptCanCirBuf->ulReadIndex;                             /* ±                     */
        if (ptCanCirBuf->ptCanFramBuf[ulIndex].ucTtypeFormat != BUF_BLANK) {
            //֡֡д֮ǰucTtypeFormat = BUF_BLANK
            *ptCanFrame = ptCanCirBuf->ptCanFramBuf[ulIndex];
            ptCanCirBuf->ulReadIndex += 1;                              /* ָ1                    */
            if (ptCanCirBuf->ulReadIndex == ptCanCirBuf->ulLength) {
                ptCanCirBuf->ulReadIndex = 0;                           /* γɻλ               */
            }
            ptCanCirBuf->bIsFull = false;                               /* 㻺־             */
            ucReturn = CAN_OK;
        }
    }
    __EXIT_CIRTICAL(ucEnable);                                          /* ˳ٽ                   */
    
    return ucReturn;
}



/*********************************************************************************************************
** Function name:           canCirBufWrite
** Descriptions:            ѭдһ֡
** input parameters:        ptCanBuf   ָѭеָ
** output parameters:       ptFrame    ָ
** Returned value:          CAN_OK    ɹ
**                          CAN_ERROR       ʧ
** Created By:              չ
** Created date:            2008.09.02
**--------------------------------------------------------------------------------------------------------
** Modified by:             չ
** Modified date:           2009.04.29
** Descriptions:            ֡͸ʽıŵֹ
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
INT8U canCirBufWrite(CANCIRBUF *ptCanCirBuf, CANFRAME *ptCanFrame)
{
    CANFRAME *ptCanFrameObject;
    INT8U i = 0;
    
    ptCanFrameObject = canCirBufMalloc(ptCanCirBuf);                    /* ӻһ֡ĵĴ洢   */
                                                                        /* ռ                         */
    if (ptCanFrameObject == (CANFRAME *)0) {                            /* δɹ         */
        return CAN_ERROR;
    }
    ptCanFrameObject->ucDLC = ptCanFrame->ucDLC;                        /* ݳ               */
    ptCanFrameObject->ulID  = ptCanFrame->ulID;                         /* ID־ַ           */
    for (i= 0; i < 8; i++) {
        ptCanFrameObject->ucDatBuf[i] = ptCanFrame->ucDatBuf[i];        /* ݳ               */
    }
    ptCanFrameObject->ucTtypeFormat = ptCanFrame->ucTtypeFormat;        /* дͣʹ֡Ч   */
    return CAN_OK;                                                      /* زɹ                 */
}



/*********************************************************************************************************
** Function name:           canNodeCreate
** Descriptions:            ʼһCANڵϢĽṹ
** input parameters:        ptCanNode:ָڵṹָ
**                          ulBaseAddr:ڵӦCANַ
**                          ulBaudIn:ڵͨŲʣʱ
**                          ulDaReObjMsk:λѡͨڽ֡ıĶ
**                          ulRmReObjMsk:λѡͨڽԶ֡ıĶ
**                          ulTxMsgObjNr:͵ıı
**                          ptRecvList:ָ򱾽ڵĽ""ṹ
**                          pfCanHandlerCallBack:ָcanHandler()صָ
** output parameters:       *ptCanNodeʼ
** Returned value:          
** Created By:              չ
** Created date:            2009.10.23
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canNodeCreate(CANNODEINFO *ptCanNode, unsigned long ulBaseAddr, unsigned char ucBaudIndex,
                   unsigned long ulDaReObjMsk, unsigned long ulRmReObjMsk, unsigned long ulTxMsgObjNr,
				   CANCIRBUF *ptReCirBuf, void (*pfCanHandlerCallBack)(unsigned long ulMessage, long lParam1, long lParam2),
				   void (*pfIsrHandler)(void))
{
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return;
    }
    // ʼ
    ptCanNode->ulBaseAddr    = ulBaseAddr;                              /* CANַ              */
    ptCanNode->ucNodeState   = CAN_NO_ERROR;
    ptCanNode->ucBaudIndex   = ucBaudIndex;                             /* CAN          */
    ptCanNode->ulBofTimer    = 0;
    
    ptCanNode->ulDaReObjMsk  = ulDaReObjMsk;                            /* ֡Ķ           */
    ptCanNode->ulRmReObjMsk  = ulRmReObjMsk;
    ptCanNode->ulTxMsgObjNr  = ulTxMsgObjNr;                            /* ͱĶ                 */
    
    ptCanNode->ptCanReCirBuf = ptReCirBuf;                              /* ָ             */
    ptCanNode->ptCanTxCirBuf = 0;                                       /* շ             */
    
    ptCanNode->pfCanHandlerCallBack = pfCanHandlerCallBack;             /* ʼص               */
    ptCanNode->pfIsrHandler = pfIsrHandler;                             /* жϷ                 */
}


/*********************************************************************************************************
** Function name:           canNodeCallBackSet
** Descriptions:            ýڵص
** input parameters:        ptCanNode              ָڵṹָ
**                          pfCanHandlerCallBack      ָصĺָ
** output parameters:       
** Returned value:          
** Created By:              չ
** Created date:            2009.05.22
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canNodeCallBackSet(CANNODEINFO *ptCanNode, void (*pfCanHandlerCallBack)(unsigned long ulMessage, long lParam1, long lParam2))
{
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return;
    }
    ptCanNode->pfCanHandlerCallBack = pfCanHandlerCallBack;
}
/*********************************************************************************************************
** Function name:           canFrameSend
** Descriptions:            һ֡CAN
** input parameters:        pCAN           ָͱĽṹָ
**                          pFrame         ݿָ
** output parameters:       
** Returned value:          
** Created By:              ά
** Created date:            2007.09.16
**--------------------------------------------------------------------------------------------------------
** Modified by:             Ni Likao 
** Modified date:           2007.11.02
**--------------------------------------------------------------------------------------------------------
** Modified by:             չ
** Modified date:           2008.11.07
** Descriptions:            Զ֡͹
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canFrameSend(CANNODEINFO *ptCanNode, CANFRAME *ptCANFrame)
{
    CAN_MSG_OBJ tMsgObjectTx;
    unsigned char ucEnable = 0;
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return;
    }
    
    ucEnable = __ENTER_CIRTICAL();                                      /* ٽ                   */
    tMsgObjectTx.ulMsgID = ptCANFrame->ulID;                            /* ȡñıʶ               */
    
    if ((ptCANFrame->ucTtypeFormat & XTD_MASK) != 0){
        tMsgObjectTx.ulFlags = MSG_OBJ_EXTENDED_ID;                     /* չʽ֡                   */
    } else {
        tMsgObjectTx.ulFlags = MSG_OBJ_NO_FLAGS;                        /* ׼ʽ֡                   */
    }
    
    tMsgObjectTx.ulFlags |= MSG_OBJ_TX_INT_ENABLE;                      /* Ƿжʹ             */
    tMsgObjectTx.ulMsgLen = (unsigned long)ptCANFrame->ucDLC;           /* 򳤶               */
    tMsgObjectTx.pucMsgData = ptCANFrame->ucDatBuf;                     /* ݴָ             */
    CANRetrySet(ptCanNode->ulBaseAddr, true);                           /* ʧط             */
    
    if ((ptCANFrame->ucTtypeFormat & RMRQS_MASK) != 0) {
        CANMessageSet(ptCanNode->ulBaseAddr,                            /* CANַ                */
        ptCanNode->ulTxMsgObjNr,                                        /* ͱĶ             */
        &tMsgObjectTx, MSG_OBJ_TYPE_TX_REMOTE);                         /* Զ֡ͱĶ       */
    } else {
        CANMessageSet(ptCanNode->ulBaseAddr,                            /* CANַ                */
        ptCanNode->ulTxMsgObjNr,                                        /* ͱĶ             */
        &tMsgObjectTx, MSG_OBJ_TYPE_TX);                                /* ֡ͱĶ       */
    }
    __EXIT_CIRTICAL(ucEnable);                                          /* ˳ٽ                   */
}

/*********************************************************************************************************
** Function name:        canReMsgObjSet
** Descriptions:         ý֡Զ֡ıĶ,ѡͨĶ򽫱ĶFIFO
** input parameters:     ulBaseAddr      CANģַ
**                       ulMsgObjMask    λѡͨҪõıĶ
**                       ulFrameID       ֡ID
**                       ulFrameIDMsk   ֡
**                       ucFramType      STD_ID_FILTER    ˽ձ׼ʽı
**                                       EXT_ID_FILTER    ˽չʽı
**                                       STD_EXT_FILTER   ˽ձ׼չʽıģʹID
**                       ucMsgType       MSG_OBJ_TYPE_RX          ձĶ
**                                       MSG_OBJ_TYPE_RX_REMOTE   Զ֡Ķ
** output parameters:    
** Returned value:       
** Created By:           չ
** Created date:         2008.08.28
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canReMsgObjSet(CANNODEINFO *ptCanNode, unsigned long ulMsgObjMask, unsigned long ulFrameID,
                    unsigned long ulFrameIDMsk, unsigned char ucFramType, unsigned char ucMsgType)
{
    CAN_MSG_OBJ tMsgObj;
    
    //unsigned long ulBaseAddr;
    LPC_CAN_TypeDef *ptCanBase;
    unsigned char ucDataBuf[8];
    unsigned short usCmdMaskReg;
    unsigned short usMaskReg[2];
    unsigned short usArbReg[2];
    unsigned short usMsgCtrl;
    tBoolean bUseExtendedID = false;
    tBoolean bEob           = false;
    int i;
    
    
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return;
    }
    
    ptCanBase   = (LPC_CAN_TypeDef *)(ptCanNode->ulBaseAddr);
    
    if (ulMsgObjMask == 0) {
        return;                                                         /* ûѡĶ             */
    }
    
    if (ucMsgType == MSG_OBJ_TYPE_RX) {                                 /* ֡ձĶ           */
        ptCanNode->ulDaReObjMsk |= ulMsgObjMask;                        /* λǽձĶ         */
    } else if (ucMsgType == MSG_OBJ_TYPE_RX_REMOTE){                    /* Զ֡Ľն           */
        ptCanNode->ulRmReObjMsk |= ulMsgObjMask;                        /* λ""Ķ       */
    } else {
        return;                                                         /* Ƿֱ˳˺     */
    }
    
    tMsgObj.ulMsgID = ulFrameID;                                        /* ˲ID                   */
    tMsgObj.ulMsgIDMask = ulFrameIDMsk;                                 /* ID*/ /* ձĶ */
    switch (ucFramType) {                                               /* ֡ʹ                   */
        case STD_ID_FILTER: {                                           /* ׼֡                       */
            tMsgObj.ulFlags = (MSG_OBJ_RX_INT_ENABLE |                  /* ж                 */
            MSG_OBJ_USE_ID_FILTER |                                     /* ʹñID˲               */
            MSG_OBJ_USE_EXT_FILTER |                                    /* Xtd˲                  */
            MSG_OBJ_USE_DIR_FILTER);                                    /* Dir˲                  */
            bUseExtendedID = false;                                     /* չ֡                   */
            break;
        }
        case EXT_ID_FILTER: {                                           /* չ֡                       */
            tMsgObj.ulFlags = (MSG_OBJ_RX_INT_ENABLE |                  /* ж                 */
            MSG_OBJ_EXTENDED_ID |                                       /* չID                       */
            MSG_OBJ_USE_ID_FILTER |                                     /* ʹñID˲               */
            MSG_OBJ_USE_EXT_FILTER |                                    /* Xtd˲                  */
            MSG_OBJ_USE_DIR_FILTER);                                    /* Dir˲                  */
            bUseExtendedID = true;                                      /* չ֡                     */
            break;
        }
        case STD_EXT_FILTER: {                                          /* ֻԽձĶ       */
            tMsgObj.ulFlags = (MSG_OBJ_RX_INT_ENABLE |                  /* ж                 */
            MSG_OBJ_USE_ID_FILTER |                                     /* ʹñID˲               */
            MSG_OBJ_USE_DIR_FILTER);                                    /* Dir˲                  */
            ulFrameIDMsk   = 0x00000000UL;                              /* IDн˲           */
            bUseExtendedID = false;                                     /* չ֡(ûӰ)       */
            break;
        }
        default: {
            return;
        }
    }
    
    
    
    tMsgObj.pucMsgData = ucDataBuf;                                     /* ָݴ洢ռ             */
    tMsgObj.ulMsgLen = 8;                                               /* 򳤶               */
    while(__canRegRead((unsigned long)&ptCanBase->IF1_CMDREQ) & CAN_IF1CRQ_BUSY) {;}
                                                                        /* ȴĴ           */
    
    usCmdMaskReg = CAN_IF1CMSK_WRNRD |                                  /* дݵĶ洢       */
    CAN_IF1CMSK_DATAA |                                                 /* ֽ 03            */
    CAN_IF1CMSK_DATAB |                                                 /* ֽ 47            */
    CAN_IF1CMSK_CONTROL |                                               /* λ                   */
    CAN_IF1CMSK_ARB;                                                    /* ID+Dir+Xtd+MsgValMsgObj*/
    
    usArbReg[0] = 0;
    usMsgCtrl = 0;
    usMaskReg[0] = 0;
    usMaskReg[1] = 0;
    
    switch(ucMsgType) {                                                 /* Ķʹ             */
        case MSG_OBJ_TYPE_RX: {                                         /* ֡               */
            usArbReg[1] = 0;
            break;
        }
        case MSG_OBJ_TYPE_RX_REMOTE: {                                  /* Զ֡               */
            usArbReg[1] = CAN_IF1ARB2_DIR;                              /* λķλ,ͷ      */
            usMsgCtrl = CAN_IF1MCTL_UMASK;                              /* MskMXtdMDirڽ˲  */
            usMaskReg[0] = 0xffff;
            usMaskReg[1] = 0x1fff;
            usCmdMaskReg |= CAN_IF1CMSK_MASK;
            break;
        }
        default: {
            return;
        }
    }
    
    if(tMsgObj.ulFlags & MSG_OBJ_USE_ID_FILTER) {                       /* ʹñID˲               */
        if(bUseExtendedID) {                                            /* չ֡                       */
            usMaskReg[0] = ulFrameIDMsk & CAN_IF1MSK1_IDMSK_M;
            usMaskReg[1] = (ulFrameIDMsk >> 16) & CAN_IF1MSK2_IDMSK_M;
        } else {                                                        /* ׼֡                       */
            usMaskReg[0] = 0;                                           /* ʮλMSK[15:0]Ϊ0         */
            usMaskReg[1]  = (ulFrameIDMsk << 2) & CAN_IF1MSK2_IDMSK_M;  /* MSK[28:18]Ϊ׼֡ID MSK     */
        }
    }
    
    if((tMsgObj.ulFlags & MSG_OBJ_USE_EXT_FILTER) ==  MSG_OBJ_USE_EXT_FILTER) {
        usMaskReg[1] |= CAN_IF1MSK2_MXTD;                               /* չʶXtd˲    */
    }
    
    if((tMsgObj.ulFlags & MSG_OBJ_USE_DIR_FILTER) == MSG_OBJ_USE_DIR_FILTER) {
        usMaskReg[1] |= CAN_IF1MSK2_MDIR;                               /* ķDir˲      */
    }
    
    if(tMsgObj.ulFlags & (MSG_OBJ_USE_ID_FILTER | MSG_OBJ_USE_DIR_FILTER | MSG_OBJ_USE_EXT_FILTER)) {
        usMsgCtrl |= CAN_IF1MCTL_UMASK;                                 /* MskMXtdMDirڽ˲  */
        usCmdMaskReg |= CAN_IF1CMSK_MASK;                               /* IDMask+Dir+Mxtd MsgObj */
    }
    
    if(bUseExtendedID) {                                                /* չ֡ID                 */
        usArbReg[0] |= ulFrameID & CAN_IF1ARB1_ID_M;
        usArbReg[1] |= (ulFrameID >> 16) & CAN_IF1ARB2_ID_M;
        usArbReg[1] |= CAN_IF1ARB2_MSGVAL | CAN_IF1ARB2_XTD;
    }  else {                                                           /* ׼֡ID                 */
        usArbReg[0] = 0;
        usArbReg[1] |= (ulFrameID << 2) & CAN_IF1ARB2_ID_M;
        usArbReg[1] |= CAN_IF1ARB2_MSGVAL;
    }
    
    usMsgCtrl |= (tMsgObj.ulMsgLen & CAN_IF1MCTL_DLC_M) | CAN_IF1MCTL_EOB;
                                                                        /* Eob = 1                      */
    if(tMsgObj.ulFlags & MSG_OBJ_RX_INT_ENABLE) {
        usMsgCtrl |= CAN_IF1MCTL_RXIE;                                  /* ʹܽж                 */
    }
    
    __canRegWrite((unsigned long)&ptCanBase->IF1_CMDMSK, usCmdMaskReg);
    __canRegWrite((unsigned long)&ptCanBase->IF1_MSK1, usMaskReg[0]);
    __canRegWrite((unsigned long)&ptCanBase->IF1_MSK2, usMaskReg[1]);
    __canRegWrite((unsigned long)&ptCanBase->IF1_ARB1, usArbReg[0]);
    __canRegWrite((unsigned long)&ptCanBase->IF1_ARB2, usArbReg[1]);
    __canRegWrite((unsigned long)&ptCanBase->IF1_MCTRL, usMsgCtrl);
    
    
    bEob = false;
    for (i = 0; i < 32; i++){
        if (ulMsgObjMask & 0x80000000) {
            if (bEob == false) {
                __canRegWrite((unsigned long)&ptCanBase->IF1_MCTRL, (usMsgCtrl | CAN_IF1MCTL_EOB));
                bEob = true;                                            /* End of the FIFO              */
            } else {
                __canRegWrite((unsigned long)&ptCanBase->IF1_MCTRL, (usMsgCtrl & (~CAN_IF1MCTL_EOB)));
            }
            __canRegWrite((unsigned long)&ptCanBase->IF1_CMDREQ, ((32 - i) & CAN_IF1CRQ_MNUM_M));
                                                                        /* µĶ               */
            while(__canRegRead((unsigned long)&ptCanBase->IF1_CMDREQ) & CAN_IF1CRQ_BUSY) {
                ;                                                       /* ȴĴ           */
            }
        }
        ulMsgObjMask = ulMsgObjMask << 1;                               /* αĶѡ         */
        if (ulMsgObjMask == 0) {
            break;                                                      /* ǰ˳ѭ                 */
        }
    }
    return;
}



/*********************************************************************************************************
** Function name:           canAcceptFilterSet
** Descriptions:            ˲
** input parameters:        ptCanNode       ָڵָ
**                          ulFrameID       ֡ID
**                          ulFrameIDMsk   ֡ID
**                          ucFramType      STD_ID_FILTER    ˽ձ׼ʽı
**                                          EXT_ID_FILTER    ˽չʽı
**                                          STD_EXT_FILTER   ˽ձ׼չʽıģʹID
** output parameters:       
** Returned value:          
** Created By:              չ
** Created date:            2008.08.28
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canAcceptFilterSet(CANNODEINFO *ptCanNode, unsigned long ulFrameID, unsigned long ulFrameIDMsk,
                        unsigned char ucFramType)
{
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return;
    }
    canReMsgObjSet(ptCanNode, ptCanNode->ulDaReObjMsk,
    ulFrameID, ulFrameIDMsk, ucFramType, MSG_OBJ_TYPE_RX);
                                                                        /* ֡ձĶ       */
    canReMsgObjSet(ptCanNode, ptCanNode->ulRmReObjMsk,
    ulFrameID, ulFrameIDMsk, ucFramType, MSG_OBJ_TYPE_RX_REMOTE);
                                                                        /* Զ֡ձĶ       */
}

/*********************************************************************************************************
** Function name:           canIntEnable
** Descriptions:            ʹCANж
** input parameters:        pCAN           ָڵָ
** output parameters:       
** Returned value:          
** Created By:              չ
** Created date:            2009.11.10
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canIntEnable (CANNODEINFO *ptCanNode)
{
    unsigned long ulIntNum;
    
    if(ptCanNode == 0) {                                                /* ڵЧж               */
        return ;
    }
    
    if (ptCanNode->pfIsrHandler) {                                      /* жϷעISR    */
        CANIntRegister(ptCanNode->ulBaseAddr, ptCanNode->pfIsrHandler);
    } else {
        ulIntNum = __canIntNumberGet(ptCanNode->ulBaseAddr);
        IntEnable(ulIntNum);                                            /* ʹCANڵж(to CPU)      */
    }
    CANIntEnable(ptCanNode->ulBaseAddr, CAN_INT_MASTER | CAN_INT_ERROR);
                                                                        /* жϼжϲʹ */
                                                                        /* CAN жԴ             */
}

/*********************************************************************************************************
** Function name:           canApplyInit
** Descriptions:            CANӦóʼжϷʼCAN趨ʼ˲ȣ
** input parameters:        ptCanNode    ָCANڵṹָ
**                          ulFrameID    ĵID
**                          ulFrameIDMsk ID루ӦλΪ1ʱʾIDĶӦλ˲
**                          ucFramType   յ֡ͣ
**                             STD_ID_FILTER   ˽ձ׼ʽı
**                             EXT_ID_FILTER   ˽չʽı
**                             STD_EXT_FILTER  ˽ձ׼չʽıģʹô
**                                             ʱulFrameIDulFrameIDMskΪЧиʽı
**                          pfun         ָжϷĺָ
** output parameters:       
** Returned value:          
** Created By:              ά
** Created date:            2007.09.16
**--------------------------------------------------------------------------------------------------------
** Modified by:             Ni Likao 
** Modified date:           2007.11.02
**--------------------------------------------------------------------------------------------------------
** Modified by:             չ
** Modified date:           2008.11.11
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
INT8U canApplyInit(CANNODEINFO *ptCanNode, unsigned long ulFrameID, unsigned long ulFrameIDMsk, unsigned char ucFramType)
{
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return CAN_ERROR;
    }
    
    // Ӳʼ
    LPC_SYSCON->PRESETCTRL |= (0x1<<3);                                 /* Peripheral reset control     */
    LPC_SYSCON->SYSAHBCLKCTRL |= (1<<17);                               /* System AHB clock control     */
    LPC_CAN->CLKDIV = 0x00;                                             /* Divided by 6                 */
    
    CANInit(ptCanNode->ulBaseAddr);                                     /* ʼCAN              */
    CANBitTimingSet(ptCanNode->ulBaseAddr, (CAN_BIT_CLK_PARM *)(&CANBitClkSettings[ptCanNode->ucBaudIndex]));
                                                                        /* 趨ڵ㲨               */
    CANEnable(ptCanNode->ulBaseAddr);                                   /* ˳ʼģʽCANڵ  */
    
    // ˲
    canAcceptFilterSet(ptCanNode, ulFrameID, ulFrameIDMsk, ucFramType);
                                                                        /* ˲                 */
    // жʹ
    canIntEnable(ptCanNode);                                            /* עжϷʹCANж*/
    return CAN_OK;
}


/*********************************************************************************************************
** Function name:           canCirBufSend
** Descriptions:            ָѭе֡ݵķ͹
** input parameters:        ptBuf  ָѭеָ
** global variable:         GptCanCirBuf:͵Ļڵַ
**                          GbCanCirBufSend:־Ƿ񽫻ݷͳȥ
** Returned value:          EMPTY         Ϊ
**                          NOT_EMPTY     治
**                          CAN_ERROR          ѭд󣬲ʧ
**
** Created By:              չ
** Created date:            2008.09.10
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
INT8U canCirBufSend(CANNODEINFO *ptCanNode, CANCIRBUF *ptCanCirBuf)
{
    CANFRAME  tCanFrame;
    unsigned char ucEnable = 0;
    
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return CAN_ERROR;
    }
    
    if (ptCanNode->ptCanTxCirBuf != (CANCIRBUF *)0) {                   /* ""ڷͶ       */
        return BUSY;
    }
                                                                        /* Ҫ͵CANڵ          */
    if (canCirBufRead(ptCanCirBuf, &tCanFrame) != CAN_OK) {             /* Ϊ,        */
        return CAN_ERROR;
    }
    
    ucEnable = __ENTER_CIRTICAL();                                      /* ٽ                   */
    ptCanNode->ptCanTxCirBuf = ptCanCirBuf;                             /* Ҫ͵Ļ׵ַ   */
    ptCanNode->ucNodeState &= ~CAN_FRAM_SEND;                           /* ״̬Ϊδɡ     */
    canFrameSend(ptCanNode, &tCanFrame);                                /* һ֡ݣݽ     */
                                                                        /* жм             */
    __EXIT_CIRTICAL(ucEnable);                                          /* ˳ٽ                   */
    return CAN_OK;                                                      /* ز                 */
}

/*********************************************************************************************************
** Function name:           canHandler
** Descriptions:            ʵжϽһ֡֡CANģԼͳɹı־
** input parameters:        ptCanNodeָCANڵָ
** output parameters:       
** Returned value:          
** Modified by:             չ
** Modified date:           2008.09.20
** Descriptions:            CANжϴ
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canHandler(CANNODEINFO *ptCanNode)
{
    CANFRAME        *ptCanFrame;
    CANFRAME        tCanFrame;
    CAN_MSG_OBJ     tMsgObjBuf;
    
    unsigned long   ulMsgObjID;
    unsigned long   ulNewData;
    unsigned long   ulTxObjMask = 1UL << (ptCanNode->ulTxMsgObjNr - 1);
    INT32U ulStatus = 0;
    INT32U ulTxReq  = 0;
    INT32U ulBit    = 0;
    INT8U i = 0;
    unsigned long ulCallBackMsg = CAN_NO_ERROR;
    
    
    ulMsgObjID = CANIntStatus(ptCanNode->ulBaseAddr,CAN_INT_STS_OBJECT);
                                                                        /* ȡжϱ־,ڷ״̬ж*/
    ulStatus   = CANStatusGet(ptCanNode->ulBaseAddr, CAN_STS_CONTROL);
    ulNewData  = CANStatusGet(ptCanNode->ulBaseAddr, CAN_STS_NEWDAT);
    ulTxReq    = CANStatusGet(ptCanNode->ulBaseAddr, CAN_STS_TXREQUEST);
    ulNewData &= ~ulTxObjMask;                                          /* ԷͱĶNewDat     */
    
    if (ulStatus & CAN_STATUS_LEC_MSK ) {
        ptCanNode->ucNodeState |= CAN_SEND_FAIL;                        /* ʧ,˴      */
    } else {
        ptCanNode->ucNodeState &= ~CAN_SEND_FAIL;                       /* ͨųɹ־       */
    }
    
    if (ulStatus & CAN_STATUS_BUS_OFF) {
        CANIntDisable(ptCanNode->ulBaseAddr, CAN_INT_MASTER | CAN_INT_ERROR);
                                                                        /* رCANж                  */
        ptCanNode->ucNodeState |= CAN_BUS_OFF;                          /*                      */
        ptCanNode->ulBofTimer = 0;
        
        ulCallBackMsg |= CAN_BUS_OFF;                                   /*                      */
    }
    
    ulStatus = ulNewData;
    if (ulMsgObjID != 0) {                                              /* ڹж                 */
        for (i = 0; i < 32; i++) {
            ulBit = 1UL << i;
            if ((ptCanNode->ulDaReObjMsk & ulNewData & ulBit) != 0){    /* յ֡                   */
                ptCanFrame = canCirBufMalloc(ptCanNode->ptCanReCirBuf); /* ȡûַ                 */
                if (ptCanFrame == (CANFRAME *)0) {                      /* ʧ,˵  */
                    ptCanFrame = &tCanFrame;                            /* þֲл,  */
                }
                tMsgObjBuf.pucMsgData = ptCanFrame->ucDatBuf;           /* ֡ݻַ           */
                CANMessageGet(ptCanNode->ulBaseAddr, (i + 1), &tMsgObjBuf, 0);
                                                                        /*                  */
                ptCanFrame->ucDLC = tMsgObjBuf.ulMsgLen;                /* ¼ݳ               */
                if (tMsgObjBuf.ulFlags & MSG_OBJ_EXTENDED_ID) {         /* չ֡ 29 λ־ַ         */
                    ptCanFrame->ulID = (tMsgObjBuf.ulMsgID & 0x1FFFFFFF);
                                                                        /* ¼CANID                */
                    ptCanFrame->ucTtypeFormat = XTD_DATA;               /* ¼Ϊչ֡             */
                } else {                                                /* ׼֡ 11 λ־ַ         */
                    ptCanFrame->ulID = (tMsgObjBuf.ulMsgID & 0x000007FF);
                                                                        /* ¼CANID                */
                    ptCanFrame->ucTtypeFormat = STD_DATA;               /* ¼Ϊ׼֡             */
                }
            } else if ((ptCanNode->ulRmReObjMsk & ulNewData & ulBit) != 0) {
                                                                        /* յԶ֡                   */
                ptCanFrame = canCirBufMalloc(ptCanNode->ptCanReCirBuf); /* ȡûַ                 */
                if (ptCanFrame == (CANFRAME *)0) {                      /* ʧ,˵  */
                    ptCanFrame = &tCanFrame;                            /* þֲл,  */
                }
                tMsgObjBuf.pucMsgData = ptCanFrame->ucDatBuf;           /* ֡ݻַ           */
                CANMessageGet(ptCanNode->ulBaseAddr, (i + 1), &tMsgObjBuf, 0);
                ptCanFrame->ucDLC = tMsgObjBuf.ulMsgLen;                /* ¼ݳ               */
                
                if (tMsgObjBuf.ulFlags & MSG_OBJ_EXTENDED_ID) {         /* չ֡ 29 λ־ַ         */
                    ptCanFrame->ulID = (tMsgObjBuf.ulMsgID & 0x1FFFFFFF);
                    ptCanFrame->ucTtypeFormat = XTD_RMRQS;              /* ¼ΪչԶ֡             */
                } else {                                                /* ׼֡ 11 λ־ַ         */
                    ptCanFrame->ulID = (tMsgObjBuf.ulMsgID & 0x000007FF);
                    ptCanFrame->ucTtypeFormat = STD_RMRQS;              /* ¼Ϊ׼Զ֡             */
                }
            }
            
            ulStatus &= ~ulBit;
            if (ulStatus == 0) {                                        /* ʣ౨ĶѾû */
                break;
            }
        }
        
        ulStatus = ulMsgObjID;
        for (i = 0; i < 32; i++) {                                      /* жϱ־                 */
            ulBit = 1UL << i;
            if (ulMsgObjID & ulBit) {
                CANIntClear(ptCanNode->ulBaseAddr, i + 1);
            }
            
            ulStatus &= ~ulBit;
            if (ulStatus == 0) {                                        /* ʣ౨ĶѾû */
                break;
            }
        }
        
        if (ulNewData & ((ptCanNode->ulRmReObjMsk) |(ptCanNode->ulDaReObjMsk))) {
                                                                        /* յ֡Զ֡           */
            ptCanNode->ucNodeState |= CAN_FRAM_RECV;                    /* յ                     */
            ulCallBackMsg |= CAN_FRAM_RECV;
        }
        
        if ((ulTxObjMask & ulMsgObjID) != 0) {                          /* ɹ                 */
            ptCanNode->ucNodeState |= CAN_FRAM_SEND;                    /*                      */
            ulCallBackMsg |= CAN_FRAM_SEND;
        }
    }
    
    // Ƿݵȴ
    ulTxReq  = CANStatusGet(ptCanNode->ulBaseAddr, CAN_STS_TXREQUEST);
    if ((ulTxReq & ulTxObjMask) == 0) {                                 /* CANǷԷվ*/
        if (ptCanNode->ptCanTxCirBuf != 0) {                            /* Ƿݵȴ       */
            if (canCirBufRead(ptCanNode->ptCanTxCirBuf, &tCanFrame) == CAN_OK) {
                ptCanNode->ucNodeState &= ~CAN_FRAM_SEND;               /* Ϊ,        */
                canFrameSend(ptCanNode, &tCanFrame);                    /* һ֡ķ͹         */
            } else {
                ptCanNode->ptCanTxCirBuf    = 0;                        /* Ͷп                 */
            }
        }
    }
    
    if (ulCallBackMsg) {                                                /* صϢͲΪ0      */
        if (ptCanNode->pfCanHandlerCallBack) {                          /* ڻص                 */
            ptCanNode->pfCanHandlerCallBack(ulCallBackMsg, ulNewData, ulMsgObjID);
        }
    }
    
    CANIntClear(ptCanNode->ulBaseAddr, CAN_INT_INTID_STATUS);           /* ״̬жϱ־             */
}



/*********************************************************************************************************
** Function name:           canNodeBusOn
** Descriptions:            CAN½ߣʼλ,ʹӦжϣ
** input parameters:        ptCanNodeָCANڵָ
** output parameters:       
** Returned value:          
** Modified by:             չ
** Modified date:           2008.09.20
** Descriptions:
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void canNodeBusOn(CANNODEINFO *ptCanNode)
{
    if (ptCanNode == 0) {                                               /* ڵЧ             */
        return;
    }
    
    CANEnable(ptCanNode->ulBaseAddr);                                   /* ˳ʼģʽCANڵ  */
    CANIntClear(ptCanNode->ulBaseAddr, CAN_INT_INTID_STATUS);           /* ״̬жϱ־             */
    CANIntEnable(ptCanNode->ulBaseAddr, CAN_INT_MASTER | CAN_INT_ERROR);/* жԴ                   */
}


/*********************************************************************************************************
END FILE
*********************************************************************************************************/
