/****************************************Copyright (c)****************************************************
**                               Guangzhou ZHIYUAN electronics Co.,LTD.
**
**                                 http://www.embedtools.com
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:               zlg_can.h
** Last modified Date:      2010.02.25
** Version:                 1.0
** Description:             zlg_can.cĽӿļ
**--------------------------------------------------------------------------------------------------------
** Created By:              չ
** Created date:            2010.02.25
** Version:                 1.0
** Descriptions:            The original version ʼ汾
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
#ifndef __ZLG_CAN_H
#define __ZLG_CAN_H

#include "dataType.h"
/*********************************************************************************************************
ѡCAN ģʱ
*********************************************************************************************************/
#define FCAN8M          8000000UL
#define FCAN6M          6000000UL
#define FCAN2M          2000000UL
#define FCAN48M         48000000UL
#define FCAN            FCAN48M                                          /* CANģʱ              */

/*********************************************************************************************************
궨աͱĶ
*********************************************************************************************************/
#define RE_DATA_SN              0x00FFFFFFUL                            /* λѡ֡ıĶ */
#define RE_REMOTE_SN            0x7F000000UL                            /* λѡԶ֡ıĶ */
#define TX_MSG_SN               32                                      /* ͱĶ             */

/*********************************************************************************************************
궨CANĻ
*********************************************************************************************************/
#define CAN_BUF_RE_LENGTH       50
#define CAN_BUF_TX_LENGTH       50

/*********************************************************************************************************
CAN ãͨҪģ
*********************************************************************************************************/
#define CAN0_GPIO_PERIPH     SYSCTL_PERIPH_GPIOD                        /* CAN0Rx = PD0 CAN0Tx = PD1    */
#define CAN0_GPIO_BASE       GPIO_PORTD_BASE
#define CAN0_GPIO_PIN        GPIO_PIN_0 | GPIO_PIN_1

#define CAN1_GPIO_PERIPH     SYSCTL_PERIPH_GPIOF                        /* CAN1Rx = PF0 CAN1Tx = PF1    */
#define CAN1_GPIO_BASE       GPIO_PORTF_BASE
#define CAN1_GPIO_PIN        GPIO_PIN_0 | GPIO_PIN_1

#define CAN2_GPIO_PERIPH     SYSCTL_PERIPH_GPIOE                        /* CAN2Rx = PE4 CAN2Tx = PE5    */
#define CAN2_GPIO_BASE       GPIO_PORTE_BASE
#define CAN2_GPIO_PIN        GPIO_PIN_4 | GPIO_PIN_5

/*********************************************************************************************************
ֵ
*********************************************************************************************************/
#define CAN_ERROR               0
#define CAN_OK                  1
#define BUSY                    2                                       /* ʾǰڷ         */


/*********************************************************************************************************
CANжϻصϢ(CANڵ״̬)
*********************************************************************************************************/
#define CAN_FRAM_RECV           0x01                                    /* ɹյ֡Զ֡     */
#define CAN_FRAM_SEND           0x02                                    /*                      */
#define CAN_BUS_OFF             0x04                                    /* ڵ                 */
#define CAN_SEND_FAIL           0x08                                     /* ʧ                     */
#define CAN_NO_ERROR            0x00                                    /* ûд                     */

/*********************************************************************************************************
չշʽ
*********************************************************************************************************/
#define EXT_ID_FILTER           1                                       /* չ֡                   */
#define STD_ID_FILTER           2                                       /* ձ׼֡                   */
#define STD_EXT_FILTER          3                                       /* ձ׼֡չ֡           */

#define UNMASK                  0x00000000UL                            /* ʹID˲                 */
#define MASK                    0x1FFFFFFFUL                            /* ID˲         */


/*********************************************************************************************************
ʱ궨
*********************************************************************************************************/
#define CANBAUD_1M              0
#define CANBAUD_500K            1
#define CANBAUD_250K            2
#define CANBAUD_125K            3
#define CANBAUD_100K            4
#define CANBAUD_50K             5
#define CANBAUD_25K             6
#define CANBAUD_20K             7
#define CANBAUD_10K             8
#define CANBAUD_5K              9
#define CANBAUD_2K5            10


/*********************************************************************************************************
֡ͼʽ
*********************************************************************************************************/
#define STD_DATA               0xF0                                     /* ׼ʽ֡               */
#define XTD_DATA               0xF2                                     /* չʽ֡               */

#define STD_RMRQS              0xF1                                     /* ׼ʽԶ֡               */
#define XTD_RMRQS              0xF3                                     /* չʽԶ֡               */

#define XTD_MASK               0x02                                     /* չ֡                   */
#define RMRQS_MASK             0x01                                     /* Զ֡                   */

#define BUF_BLANK              0x00                                     /* ǿհ֡ڶд   */

/*********************************************************************************************************
CANĽṹ
*********************************************************************************************************/
typedef struct {
    unsigned char ucTtypeFormat;                                        /* 03 ֡ͼʽ            */
    unsigned char ucDLC;                                                /* ݳ                   */
    unsigned long ulID;                                                 /* CANID                    */
    unsigned char ucDatBuf[8];                                          /* ݳ                   */
}CANFRAME;


/*********************************************************************************************************
CANջλṹ
*********************************************************************************************************/
typedef struct {
    unsigned long ulWriteIndex;                                         /* Buffer[]д±           */
    unsigned long ulReadIndex;                                          /* Buffer[]±           */
    BOOLEAN       bIsFull;
    unsigned long ulLength;                                             /* ¼                 */
    CANFRAME *ptCanFramBuf;                                             /* ָݳ             */
}CANCIRBUF;


/*********************************************************************************************************
CANṹ
*********************************************************************************************************/
typedef struct {
    unsigned long ulSysPeriph;                                          /* CANϵͳ            */
    unsigned long ulBase;                                               /* CANַ                */

    unsigned long ulGpioPeriph;                                         /* GPIO                     */
    unsigned long ulGpioBase;                                           /* GPIOӦַ                 */
    unsigned long ulGpioPin;                                            /* Ӧ                 */
} CANHARDWARE;


/*********************************************************************************************************
CANڵṹ
*********************************************************************************************************/
typedef struct {
    unsigned long ulBaseAddr;                                           /* CANַ                */
    unsigned char ucNodeState;                                          /* ڼ¼ڵ״̬             */
    unsigned char ucBaudIndex;                                          /* ʲ               */
    unsigned long ulBofTimer;                                           /* ڵߺļʱ   */
    unsigned long ulDaReObjMsk;                                         /* ֡ıĶ,λѡͨ*/
    unsigned long ulRmReObjMsk;                                         /* Զ֡ıĶ,λѡͨ*/
    unsigned long ulTxMsgObjNr;                                         /* λǷͱĶ         */
    CANCIRBUF *ptCanReCirBuf;                                           /* ָ򱾽ڵĽջ       */
    CANCIRBUF *ptCanTxCirBuf;                                           /* ָ򱾽ڵķͻ       */
    void (*pfCanHandlerCallBack)(unsigned long ulMessage, long lParam1, long lParam2);
    //ṩжϴcanHandler()Ļص,յ֡Զ֡ʱ
    void (*pfIsrHandler)(void);                                         /* CANڵжϷ        */
}CANNODEINFO;

/*********************************************************************************************************
ڶ岢ʼCANڵṹĺ
*********************************************************************************************************/
#define CANNODE(ulBaseAddr, ucBaudIndex, ulDaReObjMsk, ulRmReObjMsk,    \
                ulTxMsgObjNr,ptReCirBuf, pfCanHandlerCallBack,          \
                pfIsrHandler)                                           \
        {                                                               \
           ulBaseAddr,                                                  \
           0,                                                           \
           ucBaudIndex,                                                 \
           0,                                                           \
           ulDaReObjMsk,                                                \
           ulRmReObjMsk,                                                \
           ulTxMsgObjNr,                                                \
           (CANCIRBUF *)ptReCirBuf,                                      \
           (CANCIRBUF *)0,                                               \
           pfCanHandlerCallBack,                                        \
           pfIsrHandler,                                                \
        }


/*********************************************************************************************************
ӿں
*********************************************************************************************************/
extern INT8U canCirBufRead(CANCIRBUF *ptCanCirBuf, CANFRAME  *ptCanFrame);
extern INT8U canCirBufWrite(CANCIRBUF *ptCanCirBuf, CANFRAME *ptCanFrame);
extern INT8U canCirBufSend(CANNODEINFO *ptCanNode, CANCIRBUF *ptCanCirBuf);
extern void canFrameSend(CANNODEINFO *ptCanNode, CANFRAME  *pCANFrame);
extern void canIntEnable (CANNODEINFO *ptCanNode);
extern void canHandler(CANNODEINFO *ptCanNode);
extern void canNodeBusOn(CANNODEINFO *ptCanNode);
extern void canNodeCreate(CANNODEINFO *ptCanNode,
                          unsigned long ulBaseAddr,
                          unsigned char ucBaudIndex,
                          unsigned long ulDaReObjMsk,
                          unsigned long ulRmReObjMsk,
                          unsigned long ulTxMsgObjNr,
                          CANCIRBUF *ptReCirBuf,
                          void (*pfCanHandlerCallBack)(unsigned long ulMessage, long lParam1, long lParam2),
                          void (*pfIsrHandler)(void));
extern void canNodeCallBackSet(CANNODEINFO *ptCanNode,
                               void (*pfHandlerCallBack)(unsigned long ulMessage,
                                                         long lParam1, long lParam2));
extern void canAcceptFilterSet(CANNODEINFO *ptCanNode,
                               unsigned long ulFrameID,
                               unsigned long ulFrameIDMask,
                               unsigned char ucFramType);
extern void canReMsgObjSet(CANNODEINFO *ptCanNode,
                           unsigned long ulMsgObjMask,
                           unsigned long ulFrameID,
                           unsigned long ulFrameIDMask,
                           unsigned char ucFramType,
                           unsigned char ucMsgType);
extern INT8U canApplyInit(CANNODEINFO *ptCanNode,
                          unsigned long ulFrameID,
                          unsigned long ulFrameIDMsk,
                          unsigned char ucFramType);

/*********************************************************************************************************
ṩⲿõĽṹ峣
*********************************************************************************************************/
extern const CANFRAME GtCanFrameInit;                                   /* ѳʼΪհ׵CAN    */

#endif
