#include "ds18b20.h"
#include <stdio.h>
#include <string.h>

#include "ds18b20.h"
#include "systick_delay.h"


void Onewire_Enable_GPIO_Port(void)
{
//  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA,ENABLE);
}

void Onewire_OUT_PULL_UP(void)
{
	GPIOSetDir(PORT0,7,OUT);
	GPIOSetValue(PORT0,7,HIGH);
}


void Onewire_IN_PULL_UP(void)
{
	GPIOSetDir(PORT0,7,IN);
	GPIOSetValue(PORT0,7,HIGH);
}

void delay2_us(uint16_t us)
{
	delay_us(us*2);
}

/* Reset */
void resetOnewire(void) 
{
	Onewire_OUT_PULL_UP();
	CLR_DQ();
	delay2_us(450);
	SET_DQ();
	delay2_us(60);
	Onewire_IN_PULL_UP(); 
	delay2_us(10);
	while(!(GET_DQ()));
	Onewire_OUT_PULL_UP();
	SET_DQ();
}

/* Read */
uint8_t rOnewire(void)
{
    uint8_t data=0,i=0;
    for(i=0;i<8;i++)
    {
	Onewire_OUT_PULL_UP();
	CLR_DQ();
	data=data>>1;
	SET_DQ();
	Onewire_IN_PULL_UP();
	delay2_us(8);
	if(GET_DQ())data|=0x80;
	Onewire_OUT_PULL_UP();
	SET_DQ();
	delay2_us(60);
    }
    return(data);
}

/* Write */
void wOnewire(uint8_t data)
{
	uint8_t i=0;
	Onewire_OUT_PULL_UP();
	SET_DQ();
	delay2_us(16);
    	for(i=0;i<8;i++)
    	{
		CLR_DQ();
		if(data&0x01)
		{
			SET_DQ();
		}
   	 	else
   	 	{
			CLR_DQ();
    		}
    		data=data>>1;
		delay2_us(40);  //65
		SET_DQ();
    }
}

void OneWire_Test(void)
{
	uint8_t i,*p,id[8];

  Onewire_Enable_GPIO_Port();

  printf("Testing DS18B20 ...\r\n");

	/**----------------------Read ID------------------------*/
	p=readID();
	while(*p){id[i]=*p;p++;i++;}
	printf("DS18B20 ID :");
	i=0;
	while(i!=8){
		printf("0x%X ",id[i]);i++;
		}
	printf("\r\n");

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void convertDs18b20(void) 
{ 
    resetOnewire(); 
    wOnewire(0xcc); 
    wOnewire(0x44); 
}


uint8_t* readID(void) 
{ 
	uint8_t ID[8],i,*p;
	resetOnewire(); 
	wOnewire(0x33);
	for(i=0;i<8;i++)
	{ID[i]=rOnewire();}
	p=ID;
	return p;
}


uint32_t readTemp(void) 
{ 
	uint8_t temp1,temp2;
	convertDs18b20();
	resetOnewire(); 
	wOnewire(0xcc); 
	wOnewire(0xbe); 	
	temp1=rOnewire(); 
	temp2=rOnewire(); 
	return (((temp2<<8)|temp1)*6.25); //0.0625=xx, 0.625=xx.x, 6.25=xx.xx
}

