#include <lpc11xx.h>
#include "gpio.h"

void GPIO_Configuration(void);
void  Delay (uint32_t nCount);

int main(void)
{
	GPIOInit();
	GPIO_Configuration();
	while(1)
	{
		GPIOSetValue(PORT3,0,HIGH);
		GPIOSetValue(PORT3,1,HIGH);
		GPIOSetValue(PORT3,2,HIGH);
		GPIOSetValue(PORT3,3,HIGH);
		Delay(0xfffff);
		GPIOSetValue(PORT3,0,LOW);
		GPIOSetValue(PORT3,1,LOW);
		GPIOSetValue(PORT3,2,LOW);
		GPIOSetValue(PORT3,3,LOW);
		Delay(0xfffff);
			
	}	

}

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT3,0,OUT);
	GPIOSetDir(PORT3,1,OUT);
	GPIOSetDir(PORT3,2,OUT);
	GPIOSetDir(PORT3,3,OUT);		
}

