#include <lpc11xx.h>
#include "uart.h"

uint8_t Recived_data;		// Receive 1 byte data

/*----------------------------------------------------------------------------
  Write character to Serial Port
 *----------------------------------------------------------------------------*/
int sendchar (int c) {
    UART_send_byte(c);
    return c;
}

/*----------------------------------------------------------------------------
  Read character from Serial Port   (blocking read)
 *----------------------------------------------------------------------------*/
int getkey (void) {
    return UART_recive();
}

/************************************************/
/* ܣʼUART                       */
/************************************************/
void UART_init(uint32_t baudrate)
{
	uint32_t DL_value,Clear=Clear;   // (ַʽWarning)                       
	
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16); // ʹLPC_IOCONʱ 
	LPC_IOCON->PIO1_6 &= ~0x07;    
	LPC_IOCON->PIO1_6 |= 0x01; //P1.6ΪRXD
	LPC_IOCON->PIO1_7 &= ~0x07;	
	LPC_IOCON->PIO1_7 |= 0x01; //P1.7ΪTXD
	LPC_SYSCON->SYSAHBCLKCTRL &= ~(1<<16); // LPC_IOCONʱ

	LPC_SYSCON->UARTCLKDIV = 0x1;	//ʱӷƵֵΪ1
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<12);//LPC_UARTʱ
	LPC_UART->LCR = 0x83;   //8λ䣬1ֹͣλ޼żУ飬ʳ
	DL_value = 48000000/16/baudrate ;  //òҪĳĴֵ
	LPC_UART->DLM = DL_value / 256;	   //дλֵ			
	LPC_UART->DLL = DL_value % 256;	  //дλֵ
	LPC_UART->LCR = 0x03;    //DLAB0
	LPC_UART->FCR = 0x07;    //FIFORxFIFO  TxFIFO
	Clear = LPC_UART->LSR;   //UART״̬Ĵղ״̬
}

/************************************************/
/* ܣڽֽ                       */
/************************************************/
uint8_t UART_recive(void)
{	
	while(!(LPC_UART->LSR & (1<<0)));//ȴյ
	return(LPC_UART->RBR);			 //
}

/************************************************/
/* ܣڷֽ                       */
/************************************************/
void UART_send_byte(uint8_t byte)
{
	while ( !(LPC_UART->LSR & (1<<5)) );//ȴ
	LPC_UART->THR = byte;
}

/************************************************/
/* ܣڷ                   */
/************************************************/
void UART_send(uint8_t *Buffer, uint32_t Length)
{
	while(Length != 0)
	{
		while ( !(LPC_UART->LSR & (1<<5)) );//ȴ
		LPC_UART->THR = *Buffer;
		Buffer++;
		Length--;
	}
}


