/*========================================================================================================
*
* Hardware Environment:	Open1114
* Build Environment   : MDK-ARM Standard Version 4.22a
* By                  : WaveShare
*
*                                  (c) Copyright 2011-2016, WaveShare
*                                       http://www.waveShare.net
*                                          All Rights Reserved
*
*========================================================================================================*/
#include <lpc11xx.h>
#include "gpio.h"
#include "i2c.h"
#include "at24c16.h"
#include "uart.h"

void GPIO_Configuration(void);
void  Delay (uint32_t nCount);

int main()
{	
	uint8_t temp;
	UART_init(115200);
	printf("The I2C experiment:\r\n");
	I2C_Init(1); // ʼI2C ģʽ
	
 	if(AT24C16_Check()==0)	 // ⵽AT24C16
	{
        printf("AT24CXX OK\r\n");
	}
	else
	{   
        printf("Check AT24CXX failed!\r\n");
	}
	/*  ----  Զдֽݺ ----   */
	AT24C16_WriteOneByte(0X078,55);// AT24C16 0X0766ַдһֽݣ5
	printf("Write OK\r\n");
	temp = 0x00;  // temp 
	temp = AT24C16_ReadOneByte(0X078);	 // AT24C16 0X0766ַһֽݣtemp
	printf("Read OK\r\n");

	if(temp == 55)		  //ȡд붼ɹ
	{
        printf("verify OK :\r\n");

	}
	else	 // temp != 5,˵ȡдʧ
	{
        printf("verify failed!\r\n");
	}
	GPIO_Configuration();
    while(1)
	{
		GPIOSetValue(PORT2,4,HIGH);
		GPIOSetValue(PORT2,5,HIGH);
		GPIOSetValue(PORT2,6,HIGH);
		GPIOSetValue(PORT2,7,HIGH);
		Delay(0xfffff);
		GPIOSetValue(PORT2,4,LOW);
		GPIOSetValue(PORT2,5,LOW);
		GPIOSetValue(PORT2,6,LOW);
		GPIOSetValue(PORT2,7,LOW);
		Delay(0xfffff);	
	}

}

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT2,4,OUT);
	GPIOSetDir(PORT2,5,OUT);
	GPIOSetDir(PORT2,6,OUT);
	GPIOSetDir(PORT2,7,OUT);		
}

