#include <lpc11xx.h>
#include "timer32.h"

/****************************/
/* ܣʼTIM32B0  */
/****************************/
void TIM32B0_init(void) 
{
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<9);	//ʹTIM32B0ʱ
}

/********************************************************/
/* ܣʼTIM32B0                              */
/* ڲms ʱֵ                            */
/* ˵    ʱʱ䵽Ժ󣬻TIM32B0жϺ  */
/********************************************************/
void TIM32B0_INT_init(uint32_t ms)
{
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<9);	//ʹTIM32B0ʱ
	LPC_TMR32B0->TCR = 0x02;		//λʱbit1д1λ
	LPC_TMR32B0->PR  = 0x00;		//ԤƵĴ0ʹPC+1TC+1
	LPC_TMR32B0->MR0 = ms * 48000;	//48Mhz¹ֵ޸
	LPC_TMR32B0->IR  = 0x01;		//MR0жϸλ,жϣbit0:MR0, bit1:MR1, bit2:MR2, bit3:MR3, bit4:CP0
	LPC_TMR32B0->MCR = 0x05;		//MR0жϲʱֹͣTCPCʹTCR[0]=0, ֹͣʱж
	LPC_TMR32B0->TCR = 0x01;		//ʱTCR[0]=1;
	NVIC_EnableIRQ(TIMER_32_0_IRQn);   // ʹTIM32B0ж	
}

/*******************************/
/* ܣTIM32B0ʱ   */
/*******************************/ 
void TIM32B0_delay_ms(uint32_t ms)
{
	LPC_TMR32B0->TCR = 0x02;		//λʱbit1д1λ
	LPC_TMR32B0->PR  = 0x00;		//ԤƵĴ0ʹPC+1TC+1
	LPC_TMR32B0->MR0 = ms * 48000;	//48Mhz¹ֵ޸
	LPC_TMR32B0->IR  = 0x01;		//MR0жϸλ,жϣbit0:MR0, bit1:MR1, bit2:MR2, bit3:MR3, bit4:CP0
	LPC_TMR32B0->MCR = 0x04;		//MR0жϲʱֹͣTCPCʹTCR[0]=0, ֹͣʱ
	LPC_TMR32B0->TCR = 0x01;		//ʱTCR[0]=1;
	  
	while (LPC_TMR32B0->TCR & 0x01);//ȴʱʱʱ䵽
}

/*******************************/
/* ܣTIM32B0΢ʱ   */
/*******************************/ 
void TIM32B0_delay_us(uint32_t us)
{
	LPC_TMR32B0->TCR = 0x02;		//λʱbit1д1λ
	LPC_TMR32B0->PR  = 0x00;		//ԤƵĴ0ʹPC+1TC+1
	LPC_TMR32B0->MR0 = us * 48;	    //48Mhz¹ֵ޸
	LPC_TMR32B0->IR  = 0x01;		//MR0жϸλbit0:MR0, bit1:MR1, bit2:MR2, bit3:MR3, bit4:CP0
	LPC_TMR32B0->MCR = 0x04;		//MR0жϲʱֹͣTCPCʹTCR[0]=0, ֹͣʱ
	LPC_TMR32B0->TCR = 0x01;		//ʱTCR[0]=1;
	  
	while (LPC_TMR32B0->TCR & 0x01);//ȴʱʱʱ䵽
}

/**************************************/
/* ܣMAT0ź       */
/* ע    ⣺ﲻPWMƼĴ  */
/**************************************/ 
void TIM32B0_Square(uint32_t cycle_us)
{
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16);  // ʹIOCONʱ
	LPC_IOCON->PIO1_6 &= ~0x07;
	LPC_IOCON->PIO1_6 |= 0x02;	/* Timer0_32 MAT0 */
	LPC_SYSCON->SYSAHBCLKCTRL &= ~(1<<16);  // IOCONʱ

	LPC_TMR32B0->TCR = 0x02;		  //λʱbit1д1λ
	LPC_TMR32B0->PR  = 0x00;		  //ԤƵĴ0ʹPC+1TC+1
	LPC_TMR32B0->MR0 = (cycle_us/2) * 48;//48Mhz¹ֵ޸
	LPC_TMR32B0->IR  = 0x01;		  //MR0жϸλbit0:MR0, bit1:MR1, bit2:MR2, bit3:MR3, bit4:CP0
	LPC_TMR32B0->MCR = 0x02;		  //MR0жϲʱλTC
	LPC_TMR32B0->EMR = 0x31;		  //MR0PCʱMAT0ŷתƽ
	LPC_TMR32B0->TCR = 0x01;		  //ʱTCR[0]=1;
}

/************************************************/
/* ܣMAT0ռձȿɵź       */
/* ע    ⣺PWMƼĴ                */
/************************************************/ 
void TIM32B0_PWM(uint32_t cycle_us, uint8_t duty)
{
	if((duty>=100)&&(duty<=0))return;

	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16);  // ʹIOCONʱ
	LPC_IOCON->PIO1_6 &= ~0x07;
	LPC_IOCON->PIO1_6 |= 0x02;	      //P1.6ΪMAT0
	LPC_SYSCON->SYSAHBCLKCTRL &= ~(1<<16);  // IOCONʱ

	LPC_TMR32B0->TCR = 0x02;		  //λʱbit1д1λ
	LPC_TMR32B0->PR  = 0x00;		  //ԤƵĴ0ʹPC+1TC+1
	LPC_TMR32B0->PWMC= 0x01;		  //MAT0ΪPWM
	LPC_TMR32B0->MCR = 0x02<<9;       //MR3ƥʱλTC,ҲǰMR3ڼĴ
	LPC_TMR32B0->MR3 = 48*cycle_us;		  //
	LPC_TMR32B0->MR0 = 48*cycle_us*(100-duty)/100;//ռձ
	LPC_TMR32B0->TCR = 0x01;			  //ʱ
}

/***************************************/
/* ܣCAP0м          */
/***************************************/ 
void TIM32B0_CAP0(void)
{
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16);  // ʹIOCONʱ
	LPC_IOCON->PIO1_5 &= ~0x07;
	LPC_IOCON->PIO1_5 |= 0x02;	      //P1.5ΪCAP0
	LPC_SYSCON->SYSAHBCLKCTRL &= ~(1<<16);  // IOCONʱ

	LPC_TMR32B0->CTCR  = 0x01;		  //ѡźŵΪTCCAP0
	LPC_TMR32B0->TC    = 0x00;        //TC
	LPC_TMR32B0->TCR   = 0x01;        //ʱ
}

/***************************************/
/* ܣTIM32B0zжϷ      */
/***************************************/ 
void TIMER32_0_IRQHandler(void)
{
	if((LPC_TMR32B0->IR & 0x1)==1) // ǲMR0ж
	{
		// дִеĴ
	}
	LPC_TMR32B0->IR = 0x1F; // жϱ־	
}





