#include <lpc11xx.h>
#include "ssp.h"
#include "uart.h"
#include "gpio.h"
#include <stdio.h>
#include "ws_AT45DBXX.h"


void GPIO_Configuration(void);
void  Delay (uint32_t nCount);
int main(void)
{
	uint8_t i,temp[4];
	uint8_t tmp;
	SystemInit();
	UART_init(115200);

	AT45DBXX_Init();
	printf("SPI is ready!\r\n");

	AT45DBXX_Read_ID(temp);
        
    printf("AT45DBXX ID:");
    for(i=0;i<4;i++)
    {
        printf("0x%X ",temp[i]);
    }

	printf("\r\nFALSH AT45DBXX Write Test: \r\n");
	for(i=0;i<255;i++) /*Written to the flash*/
	{
		write_buffer((u16)i,i);
		printf("%3d ",i);
	}

	
	printf("\r\nFALSH AT45DBXX Read Test: \r\n");
	for(i=0;i<255;i++) /*Read the flash*/
	{
		tmp=read_buffer((u16)i);
		printf("%3d ",tmp);
	}
	printf("\r\nFALSH AT45DBXX Read Test Succeed!\r\n");
	
	GPIO_Configuration();
	while(1)
	{
		GPIOSetValue(PORT3,0,HIGH);
		GPIOSetValue(PORT3,1,HIGH);
		GPIOSetValue(PORT3,2,HIGH);
		GPIOSetValue(PORT3,3,HIGH);
		Delay(0xfffff);
		GPIOSetValue(PORT3,0,LOW);
		GPIOSetValue(PORT3,1,LOW);
		GPIOSetValue(PORT3,2,LOW);
		GPIOSetValue(PORT3,3,LOW);
		Delay(0xfffff);	
	}



}
/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}


/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT3,0,OUT);
	GPIOSetDir(PORT3,1,OUT);
	GPIOSetDir(PORT3,2,OUT);
	GPIOSetDir(PORT3,3,OUT);		
}
