/*********************************************************************************************************
*
* File                : ws_AT45DBXX.c
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

#include <lpc11xx.h>
#include "uart.h"
#include "gpio.h"
#include "ws_AT45DBXX.h"
#include <stdio.h>



void AT45DBXX_Init(void)
{
#ifdef Open_SPI0
	// SPIʼ
	SPI0_Init();
#else
	// SPIʼ
	SPI1_Init();
#endif

    AT45DBXX_nCS_H; //ƬѡĬΪߵƽ

}


/*static */
void AT45DBXX_BUSY(void)
{
	AT45DBXX_Enable;
    while(!(0x80 & (SPIx_communication(READ_STATE_REGISTER))))
	AT45DBXX_Disable;	
}

void AT45DBXX_Read_ID(u8 *IData)
{
	u8 i;
	AT45DBXX_BUSY();
	AT45DBXX_Enable;	
    SPIx_communication(Read_ID);
    for(i=0;i<4;i++)
        IData[i]=SPIx_communication(0xff);
  	AT45DBXX_Disable;
}

void write_buffer(u16 BufferOffset,u8 Data)
{			
	AT45DBXX_Enable;
	SPIx_communication(0x84);			
	SPIx_communication(0xff);
	SPIx_communication((u8)BufferOffset>>8);
	SPIx_communication((u8)BufferOffset);		
	SPIx_communication(Data);
	AT45DBXX_Disable;
}

u8 read_buffer(u16 BufferOffset)
{		
	u8 temp=0;
	AT45DBXX_Enable;
 	SPIx_communication(0xd4);
	SPIx_communication(0xff);
	SPIx_communication((u8)BufferOffset>>8);
	SPIx_communication((u8)BufferOffset);
	SPIx_communication(0xff);
	temp=SPIx_communication(0x00);
	AT45DBXX_Disable;
	return temp;		
}
